/* Zadatak 3A:

Organizatori biciklisti\v{c}ke utrke ``Brda Andore'' \v{c}uvaju podatke
o osiguranim to\v{c}kama utrke u vezanoj listi. Za svaku takvu to\v{c}ku
pamti se njezino ime (string od najvi\v{s}e $30$ znakova), udaljenost od
po\v{c}etka utrke (\texttt{double}, u kilometrima), te broj de\v{z}urnih
osoba na toj to\v{c}ki (\texttt{int}).
Vezana lista to\v{c}aka je uvijek \textit{uzlazno\/} sortirana po udaljenosti
od po\v{c}etka utrke. Mo\v{z}ete pretpostaviti da uvijek postoji to\v{c}ka
udaljenosti nula (start utrke) i da ne postoje dvije to\v{c}ke na istoj
udaljenosti od starta.
\begin{itemize}
  \item[(a)]
	Napi\v{s}ite definiciju odgovaraju\'{c}eg tipa podatka za \v{c}vor
	(element) liste to\v{c}aka, tako da je mogu\'{c}e definirati
	varijable naredbom \texttt{tocka t}.
	Definirajte samo podatke koji su nu\v{z}ni za \v{c}uvanje takve
	liste u memoriji.
  \item[(b)]
	Napi\v{s}ite funkciju \texttt{ucitaj}, koja sa standardnog ulaza
	u\v{c}itava podatke o osiguranim to\v{c}kama (po jedan podatak u redu,
	tj.\ $3$ reda po stvarnoj to\v{c}ki), sve dok ne u\v{c}ita
	prazno ime to\v{c}ke = oznaka za kraj niza. Funkcija treba kreirati
	uzlazno sortiranu listu to\v{c}aka i vratiti pokaziva\v{c} na njezin
	po\v{c}etak. To\v{c}ke na ulazu ne moraju biti sortirane po
	udaljenosti od starta utrke.
	Dozvoljeno je kori\v{s}tenje jednog polja za u\v{c}itavanje stringa
	i funkcije \texttt{strlen}.
  \item[(c)]
	Zbog nepovoljne vremenske prognoze (obilna ki\v{s}a), organizatori
	su odlu\v{c}ili {\bf okrenuti} smjer utrke, tako da utrka starta
	iz prvobitno planiranog cilja, a zavr\v{s}ava u prvobitno planiranom
	startu.
	Napi\v{s}ite funkciju \texttt{okreni}, koja okre\'{c}e naopako
	zadanu vezanu listu to\v{c}aka prvobitne utrke. Funkcija treba vratiti
	pokaziva\v{c} na po\v{c}etak okrenute liste. Udaljenosti od novog
	starta moraju biti korektne.

	Napomena: Algoritam mora imati linearnu slo\v{z}enost u ovisnosti o
	duljini polazne liste.
\end{itemize}

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Deklaracija tipa iz (a). */

typedef struct _tocka {
    char ime[31];
    double udaljenost;
    int broj_dezurnih;
    struct _tocka *sljed;
} tocka;

    /* Funkcija ucitaj iz (b). */

tocka* ucitaj(void)
{
    char ime[31];    // Ime za citanje.
    int len;    // Duljina ulaznog imena.
    int i;
    char c;
    tocka *novi, *prvi = NULL;
    tocka *preth, *pom;    // Za sortiranje ubacivanjem na pravo mjesto.

    while (1) {    // Petlja za citanje nove tocke, izlaz = break.

            /* Citanje imena u jednom redu (ime smije imati blankove
               pa ne koristimo %s, nego %[^\n] format).
               Pretpostavljamo da je ime dovoljno kratko da stane u string.
               U protivnom, treba dodati maksimalni broj znakova u stringu
               i petljom ucitati sve ekstra znakove do \n.
                 Unatoc tome, treba provjeriti je li ime USPJESNO ucitano,
               pa testiramo povratnu vrijednost funkcije scanf. Ako je
               jednaka 0, ime nije nadjeno -> prekidamo citanje. */
        if (scanf("%[^\n]", ime) == 0) break;

            /* Provjera duljine imena za kraj niza. */
        if ((len = strlen(ime)) == 0) break;

            /* Alokacija novog elementa liste. */
        novi = (tocka *) malloc(sizeof(tocka));

            /* Postavljanje nepraznog imena moze sa strcpy:
                 strcpy(novi->ime, ime);   --> priznaje se!
               ili petljom za kopiranje znak-po-znak. */
        for (i = 0; i <= len; ++i)
            novi->ime[i] = ime[i];    // Kopira i \0 znak, za i = len.

            /* Citanje ostalih podataka za novi element liste.
               Paziti na prioritet opreacija -> i &. */
        scanf("%lf", &(novi->udaljenost));
        scanf("%d", &(novi->broj_dezurnih));

            /* Za svaki slucaj, sljedbenik od novi = NULL. */
        novi->sljed = NULL;

// Kontrolni ispis ucitavanja:
        printf(" Ucitao  %s, %f, %d\n",
               novi->ime, novi->udaljenost, novi->broj_dezurnih);

            /* Sad radimo "insertion sort" u prethodno kreiranu listu.
               Za uzlazno sortiranje, ubaci ispred prvog veceg od novog. */
        pom = prvi;
        preth = NULL;    // Nije nuzno.

            /* Nadji prvog veceg - pom pokazuje na njega,
               a preth pokazuje na onog ispred. */
        while (pom != NULL && pom->udaljenost < novi->udaljenost) {
            preth = pom;
            pom = pom->sljed;
        }

            /* Ubaci novog izmedju preth i pom. */
        if (pom == prvi) {
            novi->sljed = prvi;
            prvi = novi;
        }
        else {
            novi->sljed = preth->sljed;
            preth->sljed = novi;
       }

            /* Striktno govoreci, na kraju obrade novog elementa, treba
               ucitati sve praznine iza zadnjeg broja, ukljucivo i
               prijelaz u novi red - zbog stringa ime.
               Ovo je NUZNO, inace se ucita samo prvi blok od 3 reda! */
        do {
            scanf("%c", &c);
        } while (c != '\n');

    }

        /* Vrati pokazivac na pocetak sortirane liste. */
    return prvi;
}

    /* Funkcija okreni iz (c). */

tocka* okreni(tocka* prvi)
{
    double max_udaljenost;    // Sluzi za okretanje udaljenosti od kraja.

    tocka *preth, *ovaj = NULL, *sljed = prvi;
    tocka *pom;

        /* Okretanje vezane lista - algoritam s predavanja. */
    while (sljed != NULL) {
        preth = ovaj;
        ovaj = sljed;
        sljed = sljed->sljed;
        ovaj->sljed = preth;    // Okreni sljedbenika od ovaj.
    }

        /* Ovaj = pokazivac na pocetak okrenute liste. */

        /* Ako ovaj nije NULL, uzmi njegovu udaljenost = max. od
           prijasnjeg starta, i postavi sve ostale udaljenosti
           na = njegova - prijasnja (jer smo okrenuli listu). */

    if (ovaj != NULL) {
        max_udaljenost = ovaj->udaljenost;
        for (pom = ovaj; pom != NULL; pom = pom->sljed)
            pom->udaljenost = max_udaljenost - pom->udaljenost;
    }

    return ovaj;
}

    /* Pomocna funkcija za ispis elemenata liste. */

void ispis(tocka *prvi)
{
    tocka *tmp;

    for (tmp = prvi; tmp != NULL; tmp = tmp->sljed) {
        printf(" ime = %s\n udalj = %g, dezurni = %d\n\n",
               tmp->ime, tmp->udaljenost, tmp->broj_dezurnih);
    }

    return;
}

    /* Glavni program za testiranje. */

int main(void)
{
    tocka *prvi, *pom;

        /* Ucitavanje elemenata. */
    prvi = ucitaj();

        /* Kontrolni ispis polazne (ucitane) liste. */
    printf("\nPolazna lista:\n");
    ispis(prvi);

        /* Okretanje liste. */
    prvi = okreni(prvi);

        /* Kontrolni ispis okrenute liste. */
    printf("\nOkrenuta lista:\n");
    ispis(prvi);


        /* Oslobadjanje elementa za listu. */
    while (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
    }

    return 0;
}
